#: SmallSize 100M
#: LargeSize 1G
#: TermsInSmall 1M
#: WorkSpace 100M
#define MAX "10"
Functions A,B,C,D;
Symbols x(:`MAX'),y,i,j;
AutoDeclare Function A,B;
Off Statistics;
.global
Load CBHcom`MAX'.sav;
.sort
#do i = 1,`MAX'
L	G`i' = FF`i';
#enddo
.sort
	repeat;
	if ( count(y,1) == 0 );
		id,once,C(?a,B,A,?b) = C(?a,A,B,?b)-C(?a,C,?b)*y;
	endif;
	endrepeat;
	id	C(?a,C) = 0;
	id	y = 1;
	repeat;
		id	C(?c,C(?a),?a) = 0;
		id,C(?c,C(?a),D?{A,B},?b) = -C(?c,C(D,?a),?b) - C(?c,D,C(?a),?b);
		id	C(?a,C) = 0;
		id	C(?c,C(B),A) = -C(?c,C(A),B);
	endrepeat;
	.sort
#do i = 1,`MAX'/2-2
	id	C(?a,D?,C(A1?,...,A`i'?)) = C(?a,C(A1,...,A`i'),D)+C(?a,C(D,A1,...,A`i'));
	#do j = 1,`i'-1
		id	C(?a,D?,C(A1?,...,A`i'?),B1?,...,B`j'?) =
				C(?a,C(A1,...,A`i'),D,B1,...,B`j')
				+C(?a,C(D,A1,...,A`i'),B1,...,B`j');
	#enddo
	id	C(C(A?,?a)) = -C(C,A,?a);
	id	C(?a,C(?b),?b) = 0;
	id	C(?a,C(?b),?c) = C(?a,C(?b),?c)*theta_(C(?b),C(?c))
						-C(?a,C(?c),?b)*thetap_(C(?c),C(?b));
	.sort
#enddo
#do cc = 1,3
	repeat;
		id	C(?c,C(?a),?a) = 0;
		id,C(?c,C(?a),D?{A,B},?b) = -C(?c,C(D,?a),?b) - C(?c,D,C(?a),?b);
		id	C(?a,C) = 0;
		id	C(?c,C(B),A) = -C(?c,C(A),B);
	endrepeat;
	.sort
#do i = 1,`MAX'/2-2
	id	C(?a,D?,C(A1?,...,A`i'?)) = C(?a,C(A1,...,A`i'),D)+C(?a,C(D,A1,...,A`i'));
	#do j = 1,`i'-1
		id	C(?a,D?,C(A1?,...,A`i'?),B1?,...,B`j'?) =
				C(?a,C(A1,...,A`i'),D,B1,...,B`j')
				+C(?a,C(D,A1,...,A`i'),B1,...,B`j');
	#enddo
	id	C(C(A?,?a)) = -C(C,A,?a);
	id	C(?a,C(?b),?b) = 0;
	id	C(?a,C(?b),?c) = C(?a,C(?b),?c)*theta_(C(?b),C(?c))
						-C(?a,C(?c),?b)*thetap_(C(?c),C(?b));
	.sort
#enddo
#enddo
Print +f;
.end

	  repeat;
		id	C(?a,C(?b),?c,C(D?,?d),?e) = C(?a,C(?b),?c,D,C(?d),?e)
				-C(?a,C(?b),?c,C(?d),D,?e);
	  endrepeat;

Local FF = F;
.sort
#do i = 1,1
	#$i = 0;
	repeat;
		if ( count(y,1) == 0 ) id,once,B*A = A*B-C*y;
	endrepeat;
	id y = 1;
	.sort
	#do j = 1,1
		#$j = 0;
		id,ifnomatch->1,C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
		$j = 1;
		Label 1;
		ModuleOption Maximum $j;
		.sort
		#if ( `$j' > 0 )
			#Redefine j "0"
		#endif
	#enddo
	if ( match(B*A) ) $i = 1;
	Repeat id,disorder,C(?a)*C(?b) = C(?b)*C(?a)-C(C(?b),?a);
	ModuleOption Maximum $i;
	.sort
	#if ( `$i' > 0 )
		#Redefine i "0"
	#endif
#enddo
#do i = 1,1
	#$i = 0;
	id,ifnomatch->2,C(?a,C(D?(?d),?c),?b) = C(?a,D(?d),C(?c),?b)-C(?a,C(?c),D(?d),?b);
	$i = 1;
	Label 2;
	ModuleOption Maximum $i;
	.sort
	#if ( `$i' > 0 )
		#Redefine i "0"
	#endif
#enddo
repeat id	C(?a,C,?b) = C(?a,A,B,?b)-C(?a,B,A,?b);
B	x;
Print +f;
.sort
Delete Storage;
#do i = 1,`MAX'
	Global FF`i' = FF[x^`i'];
#enddo
.store
Save CBHcom`MAX'.sav;
.end
#ifdef `WITHTEST'
.sort
On Statistics;
Drop FF;
L	FFF = F-FF;
#do i = 1,`MAX'-2
	id	C(D?,?a) = D*C(?a)-C(?a)*D;
	.sort
#enddo
id	C = A*B-B*A;
#endif
.end

